#ifndef __STM32F10X_H
#define __STM32F10X_H

/*Ƭַ */
#define PERIPH_BASE ((unsigned int)0x40000000)

/*߻ַGPIO ص APB2  */
#define APB2PERIPH_BASE (PERIPH_BASE + 0x10000)
 
/* AHB߻ַ */
#define AHBPERIPH_BASE        (PERIPH_BASE + 0x20000)

/*GPIO ַ*/
#define GPIOA_BASE (APB2PERIPH_BASE + 0x0800)
#define GPIOB_BASE (APB2PERIPH_BASE + 0x0C00)
#define GPIOC_BASE (APB2PERIPH_BASE + 0x1000)
#define GPIOD_BASE (APB2PERIPH_BASE + 0x1400)
#define GPIOE_BASE (APB2PERIPH_BASE + 0x1800)
#define GPIOF_BASE (APB2PERIPH_BASE + 0x1C00)
#define GPIOG_BASE (APB2PERIPH_BASE + 0x2000)

/*RCC ַ*/
#define RCC_BASE (AHBPERIPH_BASE + 0x1000)
/*RCC  AHB1 ʱʹܼĴַ,ǿתָ*/
#define RCC_APB2ENR *(unsigned int*)(RCC_BASE+0x18)

typedef unsigned int uint32_t;
typedef unsigned short uint16_t;

// GPIO Ĵṹ嶨
typedef struct
{
	uint32_t CRL;
	uint32_t CRH;
	uint32_t IDR;
	uint32_t ODR;
	uint32_t BSRR;
	uint32_t BRR;
	uint32_t LCKR;
}GPIO_TypeDef;


// GPIO 
#define GPIOA ((GPIO_TypeDef *) GPIOA_BASE)
#define GPIOB ((GPIO_TypeDef *) GPIOB_BASE)
#define GPIOC ((GPIO_TypeDef *) GPIOC_BASE)
#define GPIOD ((GPIO_TypeDef *) GPIOD_BASE)
#define GPIOE ((GPIO_TypeDef *) GPIOE_BASE)
#define GPIOF ((GPIO_TypeDef *) GPIOF_BASE)
#define GPIOG ((GPIO_TypeDef *) GPIOG_BASE)

typedef struct
{
	uint32_t CR;
	uint32_t CFGR;
	uint32_t CIR;
	uint32_t APB2RSTR;
	uint32_t APB1RSTR;
	uint32_t AHBENR;
	uint32_t APB2ENR;
	uint32_t APB1ENR;
	uint32_t BDCR;
	uint32_t CSR;
}RCC_TypeDef;

#define RCC     ((RCC_TypeDef*)RCC_BASE)

#endif

